/*
  a derived from two bases, specializing the same method
 */

#ifndef DMULSAME_H
#define DMULSAME_H

#include <iostream>

using std::cout;
using std::endl;

// doublecpp: forward declarations, DO NOT MODIFY
class BSame1; // file: d_mul_same_meth.h
class BSame2; // file: d_mul_same_meth.h
class DSame; // file: d_mul_same_meth.h
// doublecpp: end, DO NOT MODIFY

#line 13 "./d_mul_same_meth.h"
class TSame1
{
 public:
  virtual void foo1() { cout << "TSame1::foo1"; }

  virtual ~TSame1() {}
// doublecpp: dispatch methods, DO NOT MODIFY
public:
virtual void dispatch_foo(BSame1 *);
virtual void dispatch_foo(BSame2 *);
virtual void dispatch_foo(DSame *);
virtual void dispatch_m(BSame1 *);
virtual void dispatch_m(BSame2 *);
virtual void dispatch_m(DSame *);
// doublecpp: end, DO NOT MODIFY
};

// doublecpp: forward declarations, DO NOT MODIFY
class DSame; // file: d_mul_same_meth.h
// doublecpp: end, DO NOT MODIFY

#line 21 "./d_mul_same_meth.h"
class TSame2 : public TSame1
{
 public:
  void foo1() { cout << "TSame2::foo1"; }
// doublecpp: dispatch methods, DO NOT MODIFY
public:
virtual void dispatch_m(DSame *);
// doublecpp: end, DO NOT MODIFY
};

// doublecpp: forward declarations, DO NOT MODIFY
class TSame1; // file: d_mul_same_meth.h
// doublecpp: end, DO NOT MODIFY

#line 27 "./d_mul_same_meth.h"
class BSame1
{
 public:
// doublecpp: method branches, DO NOT MODIFY
#line 31 "./d_mul_same_meth.h"
virtual void m_(TSame1 * t);
virtual void m(TSame1 * t);
#line 32 "./d_mul_same_meth.h"
// doublecpp: end, DO NOT MODIFY


// doublecpp: method branches, DO NOT MODIFY
#line 36 "./d_mul_same_meth.h"
virtual void foo_(TSame1 * t);
virtual void foo(TSame1 * t);
#line 37 "./d_mul_same_meth.h"
// doublecpp: end, DO NOT MODIFY


  virtual ~BSame1() {}
};

// doublecpp: forward declarations, DO NOT MODIFY
class TSame1; // file: d_mul_same_meth.h
// doublecpp: end, DO NOT MODIFY

#line 43 "./d_mul_same_meth.h"
class BSame2
{
 public:
// doublecpp: method branches, DO NOT MODIFY
#line 47 "./d_mul_same_meth.h"
virtual void m_(TSame1 * t);
virtual void m(TSame1 * t);
#line 48 "./d_mul_same_meth.h"
// doublecpp: end, DO NOT MODIFY


// doublecpp: method branches, DO NOT MODIFY
#line 52 "./d_mul_same_meth.h"
virtual void foo_(TSame1 * t);
virtual void foo(TSame1 * t);
#line 53 "./d_mul_same_meth.h"
// doublecpp: end, DO NOT MODIFY


  virtual ~BSame2() {}
};

// doublecpp: forward declarations, DO NOT MODIFY
class TSame1; // file: d_mul_same_meth.h
class TSame2; // file: d_mul_same_meth.h
// doublecpp: end, DO NOT MODIFY

#line 59 "./d_mul_same_meth.h"
class DSame : public BSame1, public BSame2
{
 public:
  // notice that the version of m for TSame1 has to be made
  // non ambigous
// doublecpp: method branches, DO NOT MODIFY
using BSame1::m_;
using BSame2::m_;
#line 65 "./d_mul_same_meth.h"
virtual void m_(TSame1 * t);
#line 71 "./d_mul_same_meth.h"
virtual void m_(TSame2 * t);
virtual void m(TSame1 * t);
#line 77 "./d_mul_same_meth.h"
// doublecpp: end, DO NOT MODIFY


// doublecpp: method branches, DO NOT MODIFY
using BSame1::foo_;
using BSame2::foo_;
#line 81 "./d_mul_same_meth.h"
virtual void foo_(TSame1 * t);
virtual void foo(TSame1 * t);
#line 82 "./d_mul_same_meth.h"
// doublecpp: end, DO NOT MODIFY

};

#endif
