/***************************************************************************
 *   Copyright (C) 2003 by Lorenzo Bettini                                 *
 *   http://www.lorenzobettini.it                                                  *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 ***************************************************************************/

/*
  It is basically the same of deriv2.h, but in this case a class in the
  middle, Deriv1 defines the multi method as private, so Deriv2 receives
  only the branches defined in Base1
 */

#ifndef DERIV2_PRIVATE_H
#define DERIV2_PRIVATE_H

#include <iostream>

#line 22 "deriv2_private.hhh"
class T1
{
 public:
  virtual ~T1() {}

  virtual void foo() {}
};

#line 30 "deriv2_private.hhh"
class T1_d : public T1
{
  void foo() {}
};

#line 35 "deriv2_private.hhh"
class T2 : public T1_d
{
  void foo2() {}
};

#line 40 "deriv2_private.hhh"
class T3 : public T2
{
  void foo3() {}
};

#line 45 "deriv2_private.hhh"
class T4 : public T3
{
  void foo4() {}
};

// doublecpp: forward declarations, DO NOT MODIFY
class T1; // file: deriv2_private.hhh
class T2; // file: deriv2_private.hhh
// doublecpp: end, DO NOT MODIFY

#line 50 "deriv2_private.hhh"
class Base1
{
 public:
// doublecpp: method branches, DO NOT MODIFY
#line 54 "deriv2_private.hhh"
virtual void m(T1 * t);
#line 55 "deriv2_private.hhh"
virtual void m(T2 * t);
virtual void m_DB(T1 * t);
#line 58 "deriv2_private.hhh"
// doublecpp: end, DO NOT MODIFY


// doublecpp: method branches, DO NOT MODIFY
#line 62 "deriv2_private.hhh"
virtual void n(T1 * t);
#line 63 "deriv2_private.hhh"
virtual void n(T2 * t);
#line 68 "deriv2_private.hhh"
virtual void n(T1 * t, int i);
#line 69 "deriv2_private.hhh"
virtual void n(T2 * t, int i);
virtual void n_DB(T1 * t);
virtual void n_DB(T1 * t, int i);
#line 72 "deriv2_private.hhh"
// doublecpp: end, DO NOT MODIFY


  virtual ~Base1() {}
};

// doublecpp: forward declarations, DO NOT MODIFY
class T1; // file: deriv2_private.hhh
class T3; // file: deriv2_private.hhh
// doublecpp: end, DO NOT MODIFY

#line 78 "deriv2_private.hhh"
class Deriv1 : public Base1
{
  // notice that in this class the method is private
// doublecpp: method branches, DO NOT MODIFY
using Base1::m;
#line 82 "deriv2_private.hhh"
void m(T1 * t);
#line 83 "deriv2_private.hhh"
void m(T3 * t);
void m_DB(T1 * t);
#line 83 "deriv2_private.hhh"
// doublecpp: end, DO NOT MODIFY


// doublecpp: method branches, DO NOT MODIFY
using Base1::n;
#line 87 "deriv2_private.hhh"
void n(T1 * tt);
#line 88 "deriv2_private.hhh"
void n(T3 * t, int i);
void n_DB(T1 * tt);
void n_DB(T1 * t, int i);
#line 88 "deriv2_private.hhh"
// doublecpp: end, DO NOT MODIFY


  void my_meth() { n_DB(new T1); }
};

// doublecpp: forward declarations, DO NOT MODIFY
class T4; // file: deriv2_private.hhh
// doublecpp: end, DO NOT MODIFY

#line 94 "deriv2_private.hhh"
class Deriv2 : public Deriv1
{
 public:
// doublecpp: method branches, DO NOT MODIFY
#line 98 "deriv2_private.hhh"
void m(T4 * t);
virtual void m_DB(T4 * t);
#line 98 "deriv2_private.hhh"
// doublecpp: end, DO NOT MODIFY


// doublecpp: method branches, DO NOT MODIFY
#line 102 "deriv2_private.hhh"
void n(T4 * t, int i);
virtual void n_DB(T4 * t, int i);
#line 102 "deriv2_private.hhh"
// doublecpp: end, DO NOT MODIFY

};

// doublecpp: forward declarations, DO NOT MODIFY
class T3; // file: deriv2_private.hhh
// doublecpp: end, DO NOT MODIFY

#line 106 "deriv2_private.hhh"
class Deriv1_b : public Base1
{
  // notice that in this class the method is private
// doublecpp: method branches, DO NOT MODIFY
using Base1::m;
#line 110 "deriv2_private.hhh"
void m(T3 * t);
void m_DB(T1 * t);
#line 110 "deriv2_private.hhh"
// doublecpp: end, DO NOT MODIFY

};

// doublecpp: forward declarations, DO NOT MODIFY
class T4; // file: deriv2_private.hhh
// doublecpp: end, DO NOT MODIFY

#line 114 "deriv2_private.hhh"
class Deriv2_b : public Deriv1_b
{
 public:
// doublecpp: method branches, DO NOT MODIFY
#line 118 "deriv2_private.hhh"
void m(T4 * t);
void m_DB(T4 * t);
#line 118 "deriv2_private.hhh"
// doublecpp: end, DO NOT MODIFY

};

#endif
