/***************************************************************************
 *   Copyright (C) 2003 by Lorenzo Bettini                                 *
 *   http://www.lorenzobettini.it                                                  *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 ***************************************************************************/

/*
  It is basically the same of deriv2.h, but in this case a class in the
  middle, Deriv1 defines the multi method as protected, so Deriv2 receives
  only the branches defined in Base1
 */

#ifndef DERIV2_PROTECTED_H
#define DERIV2_PROTECTED_H

#include <iostream>

// doublecpp: forward declarations, DO NOT MODIFY
class Base1; // file: deriv2_protected.h
class Deriv1; // file: deriv2_protected.h
class Deriv1_b; // file: deriv2_protected.h
class Deriv2; // file: deriv2_protected.h
class Deriv2_b; // file: deriv2_protected.h
// doublecpp: end, DO NOT MODIFY

#line 22 "deriv2_protected.h"
class T1
{
 public:
  virtual ~T1() {}

  virtual void foo() {}
// doublecpp: dispatch methods, DO NOT MODIFY
public:
virtual void dispatch_m(Base1 *);
virtual void dispatch_m(Deriv2 *);
virtual void dispatch_m(Deriv2_b *);
virtual void dispatch_m(Deriv1 *);
virtual void dispatch_m(Deriv1_b *);
virtual void dispatch_n(Base1 *);
virtual void dispatch_n(Base1 *, int i);
virtual void dispatch_n(Deriv2 *, int i);
virtual void dispatch_n(Deriv1 *);
virtual void dispatch_n(Deriv1 *, int i);
// doublecpp: end, DO NOT MODIFY
};

#line 30 "deriv2_protected.h"
class T1_d : public T1
{
  void foo() {}
};

// doublecpp: forward declarations, DO NOT MODIFY
class Base1; // file: deriv2_protected.h
class Deriv1; // file: deriv2_protected.h
class Deriv1_b; // file: deriv2_protected.h
class Deriv2; // file: deriv2_protected.h
class Deriv2_b; // file: deriv2_protected.h
// doublecpp: end, DO NOT MODIFY

#line 35 "deriv2_protected.h"
class T2 : public T1_d
{
  void foo2() {}
// doublecpp: dispatch methods, DO NOT MODIFY
public:
virtual void dispatch_m(Base1 *);
virtual void dispatch_m(Deriv2 *);
virtual void dispatch_m(Deriv2_b *);
virtual void dispatch_m(Deriv1 *);
virtual void dispatch_m(Deriv1_b *);
virtual void dispatch_n(Base1 *);
virtual void dispatch_n(Base1 *, int i);
virtual void dispatch_n(Deriv2 *, int i);
virtual void dispatch_n(Deriv1 *);
virtual void dispatch_n(Deriv1 *, int i);
// doublecpp: end, DO NOT MODIFY
};

// doublecpp: forward declarations, DO NOT MODIFY
class Deriv1; // file: deriv2_protected.h
class Deriv1_b; // file: deriv2_protected.h
class Deriv2; // file: deriv2_protected.h
class Deriv2_b; // file: deriv2_protected.h
// doublecpp: end, DO NOT MODIFY

#line 40 "deriv2_protected.h"
class T3 : public T2
{
  void foo3() {}
// doublecpp: dispatch methods, DO NOT MODIFY
public:
virtual void dispatch_m(Deriv2 *);
virtual void dispatch_m(Deriv2_b *);
virtual void dispatch_m(Deriv1 *);
virtual void dispatch_m(Deriv1_b *);
virtual void dispatch_n(Deriv2 *, int i);
virtual void dispatch_n(Deriv1 *, int i);
// doublecpp: end, DO NOT MODIFY
};

// doublecpp: forward declarations, DO NOT MODIFY
class Deriv2; // file: deriv2_protected.h
class Deriv2_b; // file: deriv2_protected.h
// doublecpp: end, DO NOT MODIFY

#line 45 "deriv2_protected.h"
class T4 : public T3
{
  void foo4() {}
// doublecpp: dispatch methods, DO NOT MODIFY
public:
virtual void dispatch_m(Deriv2 *);
virtual void dispatch_m(Deriv2_b *);
virtual void dispatch_n(Deriv2 *, int i);
// doublecpp: end, DO NOT MODIFY
};

// doublecpp: forward declarations, DO NOT MODIFY
class T1; // file: deriv2_protected.h
class T2; // file: deriv2_protected.h
// doublecpp: end, DO NOT MODIFY

#line 50 "deriv2_protected.h"
class Base1
{
 public:
// doublecpp: method branches, DO NOT MODIFY
#line 54 "deriv2_protected.h"
virtual void m(T1 * t);
#line 55 "deriv2_protected.h"
virtual void m(T2 * t);
virtual void m_DB(T1 * t);
#line 58 "deriv2_protected.h"
// doublecpp: end, DO NOT MODIFY


// doublecpp: method branches, DO NOT MODIFY
#line 62 "deriv2_protected.h"
virtual void n(T1 * t);
#line 63 "deriv2_protected.h"
virtual void n(T2 * t);
#line 68 "deriv2_protected.h"
virtual void n(T1 * t, int i);
#line 69 "deriv2_protected.h"
virtual void n(T2 * t, int i);
virtual void n_DB(T1 * t);
virtual void n_DB(T1 * t, int i);
#line 72 "deriv2_protected.h"
// doublecpp: end, DO NOT MODIFY


  virtual ~Base1() {}
};

#line 78 "deriv2_protected.h"
class D : public Base1
{

};

// doublecpp: forward declarations, DO NOT MODIFY
class T1; // file: deriv2_protected.h
class T3; // file: deriv2_protected.h
// doublecpp: end, DO NOT MODIFY

#line 83 "deriv2_protected.h"
class Deriv1 : public D
{
 protected:
  // notice that in this class the method is protected
// doublecpp: method branches, DO NOT MODIFY
using Base1::m;
#line 88 "deriv2_protected.h"
void m(T1 * tt);
#line 89 "deriv2_protected.h"
void m(T3 * t);
public:
void _forward_m(T1 * tt)
{
  m(tt);
};

void _forward_m(T2 * t)
{
  m(t);
};

void _forward_m(T3 * t)
{
  m(t);
};

protected:
void m_DB(T1 * tt);
#line 89 "deriv2_protected.h"
// doublecpp: end, DO NOT MODIFY


// doublecpp: method branches, DO NOT MODIFY
using Base1::n;
#line 93 "deriv2_protected.h"
void n(T1 * tt);
#line 94 "deriv2_protected.h"
void n(T3 * t, int i);
public:
void _forward_n(T1 * tt)
{
  n(tt);
};

void _forward_n(T1 * t, int i)
{
  n(t, i);
};

void _forward_n(T2 * t)
{
  n(t);
};

void _forward_n(T2 * t, int i)
{
  n(t, i);
};

void _forward_n(T3 * t, int i)
{
  n(t, i);
};

protected:
void n_DB(T1 * tt);
void n_DB(T1 * t, int i);
#line 94 "deriv2_protected.h"
// doublecpp: end, DO NOT MODIFY

};

#line 98 "deriv2_protected.h"
class D1 : public Deriv1
{

};

// doublecpp: forward declarations, DO NOT MODIFY
class T4; // file: deriv2_protected.h
// doublecpp: end, DO NOT MODIFY

#line 103 "deriv2_protected.h"
class Deriv2 : public D1
{
 public:
// doublecpp: method branches, DO NOT MODIFY
using Deriv1::m;
#line 107 "deriv2_protected.h"
void m(T4 * t);
void m_DB(T1 * tt);
#line 107 "deriv2_protected.h"
// doublecpp: end, DO NOT MODIFY


// doublecpp: method branches, DO NOT MODIFY
using Deriv1::n;
#line 111 "deriv2_protected.h"
void n(T4 * t, int i);
void n_DB(T1 * t, int i);
#line 111 "deriv2_protected.h"
// doublecpp: end, DO NOT MODIFY

};

// doublecpp: forward declarations, DO NOT MODIFY
class T3; // file: deriv2_protected.h
// doublecpp: end, DO NOT MODIFY

#line 115 "deriv2_protected.h"
class Deriv1_b : public D
{
  // notice that in this class the method is protected
 protected:
// doublecpp: method branches, DO NOT MODIFY
using Base1::m;
#line 120 "deriv2_protected.h"
void m(T3 * t);
public:
void _forward_m(T1 * t)
{
  m(t);
};

void _forward_m(T2 * t)
{
  m(t);
};

void _forward_m(T3 * t)
{
  m(t);
};

protected:
void m_DB(T1 * t);
#line 120 "deriv2_protected.h"
// doublecpp: end, DO NOT MODIFY

};

// doublecpp: forward declarations, DO NOT MODIFY
class T4; // file: deriv2_protected.h
// doublecpp: end, DO NOT MODIFY

#line 124 "deriv2_protected.h"
class Deriv2_b : public Deriv1_b
{
 public:
// doublecpp: method branches, DO NOT MODIFY
using Deriv1_b::m;
#line 128 "deriv2_protected.h"
void m(T4 * t);
void m_DB(T1 * t);
#line 128 "deriv2_protected.h"
// doublecpp: end, DO NOT MODIFY

};

#endif
