/* gen_test_cmd.h */

/* File autogenerated by gengetopt version 2.17  */

#ifndef GEN_TEST_CMD_H
#define GEN_TEST_CMD_H

/* If we use autoconf.  */
#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

#ifndef CMDLINE_PARSER_PACKAGE
#define CMDLINE_PARSER_PACKAGE "gentest"
#endif

#ifndef CMDLINE_PARSER_VERSION
#define CMDLINE_PARSER_VERSION "1.0"
#endif

struct gengetopt_args_info
{
  const char *help_help; /* Print help and exit help description.  */
  const char *version_help; /* Print version and exit help description.  */
  char * input_arg;	/* input file (default std input).  */
  char * input_orig;	/* input file (default std input) original value given at command line.  */
  const char *input_help; /* input file (default std input) help description.  */
  const char *verbose_help; /* verbose mode on help description.  */
  const char *force_help; /* force regeneration of output code help description.  */
  const char *invade_target_help; /* directly modify sources of targets help description.  */
  const char *modular_help; /* instead of modifying targets, generate RTTI tests and casts.  Thus targets are not modified help description.  */
  int depth_arg;	/* depth of class hierarchy (default='1').  */
  char * depth_orig;	/* depth of class hierarchy original value given at command line.  */
  const char *depth_help; /* depth of class hierarchy help description.  */
  int width_arg;	/* width of class hierarchy (default='3').  */
  char * width_orig;	/* width of class hierarchy original value given at command line.  */
  const char *width_help; /* width of class hierarchy help description.  */
  char * target_prefix_arg;	/* prefix for the target class name.  */
  char * target_prefix_orig;	/* prefix for the target class name original value given at command line.  */
  const char *target_prefix_help; /* prefix for the target class name help description.  */
  char * input_header_ext_arg;	/* input header file extension (default='h').  */
  char * input_header_ext_orig;	/* input header file extension original value given at command line.  */
  const char *input_header_ext_help; /* input header file extension help description.  */
  char * output_header_ext_arg;	/* output header file extension (default='hpp').  */
  char * output_header_ext_orig;	/* output header file extension original value given at command line.  */
  const char *output_header_ext_help; /* output header file extension help description.  */
  char * output_source_ext_arg;	/* output source file extension (default='cpp').  */
  char * output_source_ext_orig;	/* output source file extension original value given at command line.  */
  const char *output_source_ext_help; /* output source file extension help description.  */
  char * output_header_suff_arg;	/* output header file suffix (def: none).  */
  char * output_header_suff_orig;	/* output header file suffix (def: none) original value given at command line.  */
  const char *output_header_suff_help; /* output header file suffix (def: none) help description.  */
  char * output_source_suff_arg;	/* output source file suffix (def: none).  */
  char * output_source_suff_orig;	/* output source file suffix (def: none) original value given at command line.  */
  const char *output_source_suff_help; /* output source file suffix (def: none) help description.  */
  int rename_overloaded_flag;	/* rename overloaded methods (default=off).  */
  const char *rename_overloaded_help; /* rename overloaded methods help description.  */
  char * rename_suffix_arg;	/* suffix for renamed method (default='_').  */
  char * rename_suffix_orig;	/* suffix for renamed method original value given at command line.  */
  const char *rename_suffix_help; /* suffix for renamed method help description.  */
  char * rename_db_suffix_arg;	/* suffix for renamed double disp method (default='_DB').  */
  char * rename_db_suffix_orig;	/* suffix for renamed double disp method original value given at command line.  */
  const char *rename_db_suffix_help; /* suffix for renamed double disp method help description.  */
  
  int help_given ;	/* Whether help was given.  */
  int version_given ;	/* Whether version was given.  */
  int input_given ;	/* Whether input was given.  */
  int verbose_given ;	/* Whether verbose was given.  */
  int force_given ;	/* Whether force was given.  */
  int invade_target_given ;	/* Whether invade-target was given.  */
  int modular_given ;	/* Whether modular was given.  */
  int depth_given ;	/* Whether depth was given.  */
  int width_given ;	/* Whether width was given.  */
  int target_prefix_given ;	/* Whether target-prefix was given.  */
  int input_header_ext_given ;	/* Whether input-header-ext was given.  */
  int output_header_ext_given ;	/* Whether output-header-ext was given.  */
  int output_source_ext_given ;	/* Whether output-source-ext was given.  */
  int output_header_suff_given ;	/* Whether output-header-suff was given.  */
  int output_source_suff_given ;	/* Whether output-source-suff was given.  */
  int rename_overloaded_given ;	/* Whether rename-overloaded was given.  */
  int rename_suffix_given ;	/* Whether rename-suffix was given.  */
  int rename_db_suffix_given ;	/* Whether rename-db-suffix was given.  */

} ;

extern const char *gengetopt_args_info_purpose;
extern const char *gengetopt_args_info_usage;
extern const char *gengetopt_args_info_help[];

int cmdline_parser (int argc, char * const *argv,
  struct gengetopt_args_info *args_info);
int cmdline_parser2 (int argc, char * const *argv,
  struct gengetopt_args_info *args_info,
  int override, int initialize, int check_required);
int cmdline_parser_file_save(const char *filename,
  struct gengetopt_args_info *args_info);

void cmdline_parser_print_help(void);
void cmdline_parser_print_version(void);

void cmdline_parser_init (struct gengetopt_args_info *args_info);
void cmdline_parser_free (struct gengetopt_args_info *args_info);

int cmdline_parser_required (struct gengetopt_args_info *args_info,
  const char *prog_name);


#ifdef __cplusplus
}
#endif /* __cplusplus */
#endif /* GEN_TEST_CMD_H */
